/* G-CTB GNU Contabilidad
 * Copyright (C) 2001 Branly Abendano, EPN Ingenieria Sistemas  
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public  
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of   
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "incl.h"
#include "CtaContable.h"
#include "interface.h"

gint FILA_ACTUAL_PLAN_CONTABLE = 0;
GnomeDbGrid *GRID_PLAN_CONTABLE;


GtkWidget* get_grid_Plan_Contable (gchar *widget_name, gchar *string1, 
				   gchar *string2, gint int1, gint int2) 
{
  	return gnome_db_grid_new(GDA_RECORDSET(GetListadoTotalDeCtasContables()));
}

void
on_cmbTipoCtaContablePlanContable_realize
                                        (GtkWidget       *widget,
                                        gpointer         user_data)   
{ 
  Gda_Recordset *grs;
 
  	grs = GDA_RECORDSET(GetListadoNombresTiposCtasContables());

  	gnome_db_combo_refresh(GTK_OBJECT(cmbTipoCtaContablePlanContable));
 
  	gnome_db_combo_set_recordset(GTK_OBJECT(cmbTipoCtaContablePlanContable),GDA_RECORDSET(grs),0);
}   

void
on_cmbTipoCtaContableMantPlanContable_realize
                                        (GtkWidget       *widget,
                                        gpointer         user_data)   
{ 
  Gda_Recordset *grs;
 
  	grs = GDA_RECORDSET(GetListadoNombresTiposCtasContables());

  	gnome_db_combo_refresh(GTK_OBJECT(cmbTipoCtaContableMantPlanContable));
 
  	gnome_db_combo_set_recordset(GTK_OBJECT(cmbTipoCtaContableMantPlanContable),GDA_RECORDSET(grs),0);
}   

void
on_gridPlanContable_realize             (GtkWidget       *widget,
                                        gpointer         user_data)
{ 
  Gda_Recordset *grs;

  	grs = GetListadoTotalDeCtasContables();

  	gnome_db_grid_clear(GNOME_DB_GRID(gridPlanContable));
  	gnome_db_grid_refresh(GNOME_DB_GRID(gridPlanContable));
  
  	gnome_db_grid_set_recordset(GNOME_DB_GRID(gridPlanContable),GDA_RECORDSET(grs));
                              
  	GRID_PLAN_CONTABLE = GNOME_DB_GRID(gridPlanContable);
}



void
on_gridPlanContable_select_row         (GnomeDbGrid     *gnomedbgrid,
                                        gint             arg1,
                                        gpointer         user_data)
{ 
   gchar *text;

    	FILA_ACTUAL_PLAN_CONTABLE = arg1; 

    	gnome_db_grid_show_row_numbers (gnomedbgrid);

    	gtk_clist_get_text(GTK_CLIST(gnomedbgrid->grid),arg1-1,0,&text);
    	gtk_entry_set_text(GTK_ENTRY (GTK_OBJECT(txtCodigoCtaContableMantPlanContable)), text );               

    	gtk_clist_get_text(GTK_CLIST(gnomedbgrid->grid),arg1-1,1,&text);
    	gtk_entry_set_text(GTK_ENTRY (GTK_OBJECT(txtNombreCtaContableMantPlanContable)), text );               

    	gtk_clist_get_text(GTK_CLIST(gnomedbgrid->grid),arg1-1,3,&text);
    	gtk_entry_set_text(GTK_ENTRY(GTK_COMBO (GTK_OBJECT(cmbTipoCtaContableMantPlanContable))->entry), text );               

    	gtk_clist_get_text(GTK_CLIST(gnomedbgrid->grid),arg1-1,4,&text);
    	gtk_entry_set_text(GTK_ENTRY (GTK_OBJECT(txtCtaTotalMantPlanContable)), text );               

    	gtk_clist_get_text(GTK_CLIST(gnomedbgrid->grid),arg1-1,5,&text);
    	gtk_entry_set_text(GTK_ENTRY (GTK_OBJECT(txtNivelCtaContableMantPlanContable)), text );               

    	gtk_clist_get_text(GTK_CLIST(gnomedbgrid->grid),arg1-1,6,&text);
    	gtk_entry_set_text(GTK_ENTRY (GTK_OBJECT(txtCtaSuperiorMantPlanContable)), text );               
} 

void
on_btnNextCtaContableMantPlanContable_clicked       (GtkButton       *button,
                                        gpointer         user_data) 
{
    	gtk_clist_unselect_row(GTK_CLIST(GRID_PLAN_CONTABLE->grid), FILA_ACTUAL_PLAN_CONTABLE-1, 0);
    	gtk_clist_select_row(GTK_CLIST(GRID_PLAN_CONTABLE->grid), FILA_ACTUAL_PLAN_CONTABLE, 0);
}

void
on_btnPriorCtaContableMantPlanContable_clicked      (GtkButton       *button,
                                        gpointer         user_data) 
{
    	gtk_clist_unselect_row(GTK_CLIST(GRID_PLAN_CONTABLE->grid), FILA_ACTUAL_PLAN_CONTABLE-1, 0);
    	gtk_clist_select_row(GTK_CLIST(GRID_PLAN_CONTABLE->grid), FILA_ACTUAL_PLAN_CONTABLE-2, 0);
}

void
on_btnLastCtaContableMantPlanContable_clicked      (GtkButton       *button,
                                        gpointer         user_data) 
{
	gtk_clist_unselect_row(GTK_CLIST(GRID_PLAN_CONTABLE->grid), FILA_ACTUAL_PLAN_CONTABLE-1, 0);
    	FILA_ACTUAL_PLAN_CONTABLE = GRID_PLAN_CONTABLE->total_rows;

    	gtk_clist_select_row(GTK_CLIST(GRID_PLAN_CONTABLE->grid), FILA_ACTUAL_PLAN_CONTABLE-1, 0);
}

void
on_btnFirstCtaContableMantPlanContable_clicked      (GtkButton       *button,
                                        gpointer         user_data) 
{
    	gtk_clist_unselect_row(GTK_CLIST(GRID_PLAN_CONTABLE->grid), FILA_ACTUAL_PLAN_CONTABLE-1, 0);
    	gtk_clist_select_row(GTK_CLIST(GRID_PLAN_CONTABLE->grid), 0, 0);
}


void
on_btnActualizarCtaContableMantPlanContable_clicked
                                        (GtkButton       *button,   
                                        gpointer         user_data) 
{
   Gda_Recordset *grs;
        
        grs = GetListadoTotalDeCtasContables();

        gnome_db_grid_clear(GNOME_DB_GRID(gridPlanContable));
        gnome_db_grid_refresh(GNOME_DB_GRID(gridPlanContable));

        gnome_db_grid_set_recordset(GNOME_DB_GRID(gridPlanContable),GDA_RECORDSET(grs));
}

void
on_btnInsertCtaContableMantPlanContable_clicked       (GtkButton       *button,
                                        gpointer         user_data)
{
   gchar *CodigoCtaContable = NULL;
   gchar *NombreCtaContable = NULL;
   gchar *TipoCtaContable = NULL;
   gchar *CodigoTipoCtaContable = NULL;
   gchar *TotalCtaContable = NULL;
   gchar *NivelCtaContable = NULL;
   gchar *CtaContableSuperior = NULL;
   Gda_Recordset *grs;
   gint rc;

        CodigoCtaContable = (gchar *)gtk_entry_get_text (GTK_ENTRY (GTK_OBJECT(txtCodigoCtaContableMantPlanContable)));
        NombreCtaContable = (gchar *)gtk_entry_get_text (GTK_ENTRY (GTK_OBJECT(txtNombreCtaContableMantPlanContable)));
        TipoCtaContable = (gchar *)gnome_db_combo_get_string (GTK_OBJECT(cmbTipoCtaContableMantPlanContable));
        TotalCtaContable = (gchar *)gtk_entry_get_text (GTK_ENTRY (GTK_OBJECT(txtCtaTotalMantPlanContable)));
        NivelCtaContable = (gchar *)gtk_entry_get_text (GTK_ENTRY (GTK_OBJECT(txtNivelCtaContableMantPlanContable)));
        CtaContableSuperior = (gchar *)gtk_entry_get_text (GTK_ENTRY (GTK_OBJECT(txtCtaSuperiorMantPlanContable)));
	CodigoTipoCtaContable = (gchar *)ConsultarCodigoTipoCtaContable(TipoCtaContable);


	rc = InsertNuevoCtaContable (CodigoCtaContable, NombreCtaContable, NombreCtaContable, CodigoTipoCtaContable,
                                     TotalCtaContable, NivelCtaContable, CtaContableSuperior);

        if (rc != 0) {
                g_print("\nNo se ingreso este registro");
        } else {
		grs = GetListadoTotalDeCtasContables();
        
                gnome_db_grid_clear(GNOME_DB_GRID(gridPlanContable));
                gnome_db_grid_refresh(GNOME_DB_GRID(gridPlanContable));
   
                gnome_db_grid_set_recordset(GNOME_DB_GRID(gridPlanContable),GDA_RECORDSET(grs));
        }
}

void
on_btnDeleteCtaContableMantPlanContable_clicked       (GtkButton       *button,
                                        gpointer         user_data)
{
   gchar *CodigoCtaContable = NULL;

   Gda_Recordset *grs;
   gint rc;
                
        CodigoCtaContable = (gchar *)gtk_entry_get_text (GTK_ENTRY (GTK_OBJECT(txtCodigoCtaContableMantPlanContable)));
         
	rc = DeleteCtaContable (CodigoCtaContable);

        if (rc != 0) {
                g_print("\nNo se borr este registro");
        } else {
                grs = GetListadoTotalDeCtasContables();

                gnome_db_grid_clear(GNOME_DB_GRID(gridPlanContable));
                gnome_db_grid_refresh(GNOME_DB_GRID(gridPlanContable));

                gnome_db_grid_set_recordset(GNOME_DB_GRID(gridPlanContable),GDA_RECORDSET(grs));        
        }
}


void
on_btnGrabarPlanContable_clicked       (GtkButton       *button,
                                        gpointer         user_data)
{
   gchar *CodigoCtaContable = NULL;
   gchar *NombreCtaContable = NULL;
   gchar *DescripcionCtaContable = NULL;
   gchar *TipoCtaContable = NULL;
   gchar *CodigoTipoCtaContable = NULL;
   gchar *TotalCtaContable = NULL;
   gchar *NivelCtaContable = NULL;
   gchar *CtaContableSuperior = NULL;

   gint rc;

        CodigoCtaContable = (gchar *)gtk_entry_get_text (GTK_ENTRY (GTK_OBJECT(txtCodigoPlanContable)));
        NombreCtaContable = (gchar *)gtk_entry_get_text (GTK_ENTRY (GTK_OBJECT(txtNombrePlanContable)));
        DescripcionCtaContable = (gchar *)gtk_entry_get_text (GTK_ENTRY (GTK_OBJECT(txtDescripcionPlanContable)));
        TipoCtaContable = (gchar *)gnome_db_combo_get_string (GTK_OBJECT(cmbTipoCtaContablePlanContable));
        TotalCtaContable = (gchar *)gtk_entry_get_text (GTK_ENTRY (GTK_OBJECT(cmbCtaTotales)));
        NivelCtaContable = (gchar *)gtk_entry_get_text (GTK_ENTRY (GTK_OBJECT(txtNivelCuentaPlanContable)));
        CtaContableSuperior = (gchar *)gtk_entry_get_text (GTK_ENTRY (GTK_OBJECT(txtCtaSuperiorPlanContable)));
	CodigoTipoCtaContable = (gchar *)ConsultarCodigoTipoCtaContable(TipoCtaContable);

        rc = InsertNuevoCtaContable (CodigoCtaContable, NombreCtaContable, DescripcionCtaContable, CodigoTipoCtaContable,
                                     TotalCtaContable, NivelCtaContable, CtaContableSuperior);
   
        if (rc != 0) {
                g_print("\nNo se ingreso este registro");
        } else {
                gtk_entry_set_text(GTK_ENTRY (GTK_OBJECT(txtCodigoPlanContable)),"");
                gtk_entry_set_text(GTK_ENTRY (GTK_OBJECT(txtNombrePlanContable)),"");
                gtk_entry_set_text(GTK_ENTRY (GTK_OBJECT(txtDescripcionPlanContable)),"");
                gtk_entry_set_text(GTK_ENTRY (GTK_OBJECT(txtNivelCuentaPlanContable)),"");
                gtk_entry_set_text(GTK_ENTRY (GTK_OBJECT(txtCtaSuperiorPlanContable)),"");
        }
        
        gtk_widget_grab_focus(txtCodigoPlanContable);
}

void
on_btnSalirPlanContable_clicked                    (GtkButton       *button,
                                                  gpointer         user_data)
{
    	gtk_exit(0);
}  

void
on_btnSalirMantenerPlanContable_clicked                    (GtkButton       *button,
                                                  gpointer         user_data)
{
    	gtk_exit(0);
}  

