/* G-CTB GNU Contabilidad
 * Copyright (C) 2001 Branly Abendano, EPN Ingenieria Sistemas  
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public  
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of   
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "rptMayores.h"


void
on_btnRptMayores_clicked      		(GtkButton       *button,
                                        gpointer         user_data)
{ 
   Gda_Recordset *grs;
   Gda_Field *field;
   Gda_Recordset *grsCta;
   gchar *CodigoCtaContable = NULL;
   gchar *NombreCtaContable = NULL;
   gchar *FechaTransaccion = NULL;
   gchar *ComprobanteTransaccion = NULL;
   gchar *DiarioTransaccion = NULL;
   gchar *DescripcionTransaccion = NULL;
   gchar *TipoTransaccion = NULL;
   gchar *CadenaValorTransaccion = NULL;
   gchar *TextoSaldoCtaContable = NULL;
   gfloat ValorTransaccion=0; 
   gfloat SaldoCtaContable=0;
   gchar *FechaInicialReportes = NULL;
   gint num =0;
   gint SenalExisteAnterior = 0;
   gchar *FechaCierreUltimo = NULL;
   gint CodigoCierreFechaAnterior = 0;
   gfloat DebeFechaIntermedio = 0;
   gfloat HaberFechaIntermedio = 0;
   gfloat SaldoDebe = 0;
   gfloat SaldoHaber = 0;
   gfloat DebeFechaAnterior = 0;
   gfloat HaberFechaAnterior = 0;
   gfloat TotalDebe = 0;
   gfloat TotalHaber = 0;
   gint g=0;

	grsCta = GDA_RECORDSET(GetListadoTotalDeCtasContablesTransacciones());

	gda_recordset_move_next (grsCta);

	if ((g=open("rptMayores.xml", O_WRONLY | O_CREAT | O_TRUNC, 0660)) != -1) {
        }

	write(g, "<?xml version=\"1.0\" encoding=\"UTF-8\"?>",strlen("<?xml version=\"1.0\" encoding=\"UTF-8\"?>"));
	write(g, "\n<RPT_MAYORES>",strlen("\n<RPT_MAYORES>"));
	write(g, "\n\t<Compania>ACNE CIA. LTDA</Compania>",strlen("\n\t<Compania>ACNE CIA. LTDA</Compania>"));
	write(g, "\n\t<Periodo>1-JAN-2000 AL 31-DEC-2000</Periodo>",strlen("\n\t<Periodo>1-JAN-2000 AL 31-DEC-2000</Periodo>"));

        FechaInicialReportes = (gchar *)gtk_entry_get_text (GTK_ENTRY(GNOME_DATE_EDIT(GTK_OBJECT(txtFechaInicialReportes))->date_entry));
        num = ConsultarVerificarExisteCierreMenorFecha(FechaInicialReportes);

        SenalExisteAnterior = 0;
        if (num > 0) {
                SenalExisteAnterior = 1;
                FechaCierreUltimo = (gchar *)ConsultarFechaCierreUltimo(FechaInicialReportes);
                CodigoCierreFechaAnterior = ConsultarCodigoCierreFecha(FechaCierreUltimo);
        }

	while (!gda_recordset_eof(grsCta)) {

		SaldoCtaContable = 0;

		DebeFechaIntermedio  = 0;
		HaberFechaIntermedio = 0;

		SaldoDebe  = 0;
		SaldoHaber = 0;
		DebeFechaAnterior  = 0;
		HaberFechaAnterior = 0;

		
		write(g, "\n\t<CtaContable>",strlen("\n\t<CtaContable>"));

        	field = gda_recordset_field_idx (GDA_RECORDSET(grsCta), 0);
        	CodigoCtaContable = (gchar *)gda_stringify_value(CodigoCtaContable, 20, field);

		if (SenalExisteAnterior == 1) {
			DebeFechaIntermedio  = ConsultarDebeCtaContableEntreDosFechas( FechaCierreUltimo, FechaInicialReportes, CodigoCtaContable);
			HaberFechaIntermedio = ConsultarHaberCtaContableEntreDosFechas( FechaCierreUltimo, FechaInicialReportes, CodigoCtaContable);

			DebeFechaAnterior  =  ConsultarDebeCierreCtaContable(CodigoCierreFechaAnterior, CodigoCtaContable);
			HaberFechaAnterior  =  ConsultarHaberCierreCtaContable(CodigoCierreFechaAnterior, CodigoCtaContable);
		}
		if (SenalExisteAnterior == 0) {
			SaldoDebe  = ConsultarDebeTotalCtaContableMenorAFecha(CodigoCtaContable, FechaInicialReportes);
			SaldoHaber = ConsultarHaberTotalCtaContableMenorAFecha(CodigoCtaContable, FechaInicialReportes);
		}

		TotalDebe  = SaldoDebe  + DebeFechaAnterior  + DebeFechaIntermedio;
		TotalHaber = SaldoHaber + HaberFechaAnterior + HaberFechaIntermedio;
		
		SaldoCtaContable = TotalDebe - TotalHaber;

		write(g, "\n\t\t<CodigoCta>",strlen("\n\t\t<CodigoCta>"));
		write(g, CodigoCtaContable,strlen(CodigoCtaContable));
		write(g, "</CodigoCta>",strlen("</CodigoCta>"));

        	field = gda_recordset_field_idx (GDA_RECORDSET(grsCta), 1);
        	NombreCtaContable = (gchar *)gda_stringify_value(NombreCtaContable, 60, field);

		write(g, "\n\t\t<NombreCta>",strlen("\n\t\t<NombreCta>"));
		write(g, NombreCtaContable,strlen(NombreCtaContable));
		write(g, "</NombreCta>",strlen("</NombreCta>"));

		TextoSaldoCtaContable = g_strdup_printf("%f",SaldoCtaContable);

		write(g, "\n\t\t<SaldoCta>",strlen("\n\t\t<SaldoCta>"));
		write(g, TextoSaldoCtaContable,strlen(TextoSaldoCtaContable));
		write(g, "</SaldoCta>",strlen("</SaldoCta>"));

  		grs    = GDA_RECORDSET(GetListadoTotalDeTransaccionesContablesPorCtaContable (CodigoCtaContable));

		gda_recordset_move_next (grs);

        	g_print("\nInicio Segundo Bucle");

		while (!gda_recordset_eof(grs)) {
			
			write(g, "\n\t\t<Registro>",strlen("\n\t\t<Registro>"));

        		field = gda_recordset_field_idx (GDA_RECORDSET(grs), 7);
        		FechaTransaccion = (gchar *)gda_stringify_value(FechaTransaccion, 15, field);

			write(g, "\n\t\t\t<Fecha>",strlen("\n\t\t\t<Fecha>"));
			write(g, FechaTransaccion,strlen(FechaTransaccion));
			write(g, "</Fecha>",strlen("</Fecha>"));

        		field = gda_recordset_field_idx (GDA_RECORDSET(grs), 2);
        		ComprobanteTransaccion = (gchar *)gda_stringify_value(ComprobanteTransaccion, 25, field);

			write(g, "\n\t\t\t<Comprobante>",strlen("\n\t\t\t<Comprobante>"));
			write(g, ComprobanteTransaccion,strlen(ComprobanteTransaccion));
			write(g, "</Comprobante>",strlen("</Comprobante>"));

        		field = gda_recordset_field_idx (GDA_RECORDSET(grs), 4);
        		DiarioTransaccion = (gchar *)gda_stringify_value(DiarioTransaccion, 25, field);

			write(g, "\n\t\t\t<Diario>",strlen("\n\t\t\t<Diario>"));
			write(g, DiarioTransaccion,strlen(DiarioTransaccion));
			write(g, "</Diario>",strlen("</Diario>"));

        		field = gda_recordset_field_idx (GDA_RECORDSET(grs), 3);
        		DescripcionTransaccion = (gchar *)gda_stringify_value(DescripcionTransaccion, 200, field);

			write(g, "\n\t\t\t<Descripcion>",strlen("\n\t\t\t<Descripcion>"));
			write(g, DescripcionTransaccion,strlen(DescripcionTransaccion));
			write(g, "</Descripcion>",strlen("</Descripcion>"));


        		field = gda_recordset_field_idx (GDA_RECORDSET(grs), 6);
        		CadenaValorTransaccion = (gchar *)gda_stringify_value(CadenaValorTransaccion, 30, field);

			sscanf(CadenaValorTransaccion,"%f",&ValorTransaccion);

        		field = gda_recordset_field_idx (GDA_RECORDSET(grs), 5);
        		TipoTransaccion = (gchar *)gda_stringify_value(TipoTransaccion, 20, field);

			if (g_strcasecmp(TipoTransaccion,"DEBE")) {
				write(g, "\n\t\t\t<Debe>",strlen("\n\t\t\t<Debe>"));
				write(g, CadenaValorTransaccion,strlen(CadenaValorTransaccion));
				write(g, "</Debe>",strlen("</Debe>"));

				write(g, "\n\t\t\t<Haber>",strlen("\n\t\t\t<Haber>"));
				write(g, " ",strlen(" "));
				write(g, "</Haber>",strlen("</Haber>"));
			
				SaldoCtaContable = SaldoCtaContable + ValorTransaccion;
			}
			if (g_strcasecmp(TipoTransaccion,"HABER")) {
				write(g, "\n\t\t\t<Debe>",strlen("\n\t\t\t<Debe>"));
				write(g, " ",strlen(" "));
				write(g, "</Debe>",strlen("</Debe>"));

				write(g, "\n\t\t\t<Haber>",strlen("\n\t\t\t<Haber>"));
				write(g, CadenaValorTransaccion,strlen(CadenaValorTransaccion));
				write(g, "</Haber>",strlen("</Haber>"));

				SaldoCtaContable = SaldoCtaContable - ValorTransaccion;
			}

			TextoSaldoCtaContable = g_strdup_printf("%f",SaldoCtaContable);

			write(g, "\n\t\t\t<Saldo>",strlen("\n\t\t\t<Saldo>"));
			write(g, TextoSaldoCtaContable,strlen(TextoSaldoCtaContable));
			write(g, "</Saldo>",strlen("</Saldo>"));

			write(g, "\n\t\t</Registro>",strlen("\n\t\t</Registro>"));

			gda_recordset_move_next (grs);

		}
		write(g, "\n\t</CtaContable>",strlen("\n\t</CtaContable>"));

		gda_recordset_free(grs);

		gda_recordset_move_next (grsCta);
	}

	write(g, "\n</RPT_MAYORES>\n",strlen("\n</RPT_MAYORES>\n"));

	gda_recordset_free(grsCta);

	close(g);


}


